Imports System.Diagnostics
Imports System.Runtime.InteropServices

Public Class Form1

    Inherits System.Windows.Forms.Form
    Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Integer
    Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByRef lParam As Object) As Integer
    Delegate Function EnumCallback(ByVal hwnd As Integer, ByVal lParam As Integer) As Boolean

    Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As EnumCallback, ByVal lParam As Integer) As Boolean
    Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Integer) As Integer
    Public Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Integer, ByVal dwReserved As Integer) As Integer


    Private Declare Function GetTopWindow Lib "user32" (ByVal hwnd As Integer) As Integer
    Private Declare Function GetDesktopWindow Lib "user32" () As Integer
    Private Declare Function GetNextWindow Lib "user32" Alias "GetWindow" (ByVal hwnd As Integer, ByVal wFlag As Integer) As Integer
    Private Declare Function GetParent Lib "user32" (ByVal hwnd As Integer) As Integer
    Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Integer, ByVal nIndex As Integer) As Integer
    Private Declare Function IsWindowVisible Lib "user32" (ByVal hwnd As Integer) As Integer
    Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Integer, ByVal lpString As String, ByVal cch As Integer) As Integer
    Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Integer, ByVal lpClassName As String, ByVal nMaxCount As Integer) As Integer


    Private Declare Function GetCurrentProcess Lib "kernel32" () As Integer
    Private Declare Function OpenProcessToken Lib "advapi32" (ByVal ProcessHandle As Integer, ByVal DesiredAccess As Integer, ByRef TokenHandle As Integer) As Integer
    Private Declare Function LookupPrivilegeValue Lib "advapi32" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, ByRef lpLuid As Form1.LUID) As Integer
    Private Declare Function AdjustTokenPrivileges Lib "advapi32" (ByVal TokenHandle As Integer, ByVal DisableAllPrivileges As Integer, ByRef NewState As Form1.TOKEN_PRIVILEGES, ByVal BufferLength As Integer, ByRef PreviousState As Form1.TOKEN_PRIVILEGES, ByRef ReturnLength As Integer) As Integer

    Private Declare Function RegisterWindowMessage Lib "user32.dll" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Integer
    Private Declare Function DeregisterShellHookWindow Lib "user32" (ByVal hWnd As IntPtr) As Integer
    Private Declare Function RegisterShellHookWindow Lib "user32" (ByVal hWnd As IntPtr) As Integer

    Private uMsgNotify As Integer

    Private _lastMouseX As Integer
    Private _lastMouseY As Integer



    Private Const HWND_BROADCAST As Integer = &HFFFF&



    Private Const EWX_LOGOFF As Integer = 0
    Private Const EWX_POWEROFF As Integer = &H8
    Private Const EWX_FORCE As Integer = &H4
    Private Const EWX_RESTART As Integer = &H2
    Private Const EWX_FORCEIFHUNG As Integer = &H10


    Private Const GW_HWNDFIRST As Integer = 0
    Private Const GW_HWNDNEXT As Integer = 2
    Private Const GWL_STYLE As Integer = (-16)
    Private Const GWL_HWNDPARENT As Integer = (-8)
    Private Const WS_OVERLAPPED As Integer = &H0&
    Private Const WS_BORDER As Integer = &H800000
    Private Const WS_DLGFRAME As Integer = &H400000
    Private Const WS_CAPTION As Integer = WS_BORDER Or WS_DLGFRAME
    Private Const WS_SYSMENU As Integer = &H80000
    Private Const WS_THICKFRAME As Integer = &H40000
    Private Const WS_MINIMIZEBOX As Integer = &H20000
    Private Const WS_MAXIMIZEBOX As Integer = &H10000
    Private Const WS_OVERLAPPEDWINDOW As Integer = (WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX)
    Private Const WM_CLOSE As Integer = &H10
    Private Const EM_SETREADONLY As Int32 = &HCF



    Private Const MONITOR_ON As Integer = -1&
    Private Const MONITOR_LOWPOWER As Integer = 1&
    Private Const MONITOR_OFF As Integer = 2&
    Private Const SC_MONITORPOWER As Integer = &HF170&
    Private Const WM_SYSCOMMAND As Integer = &H112

    Private Structure LUID
        Dim UsedPart As Integer
        Dim IgnoredForNowHigh32BitPart As Integer
    End Structure



    Private Structure TOKEN_PRIVILEGES
        Dim PrivilegeCount As Integer
        Dim TheLuid As Form1.LUID
        Dim Attributes As Integer
    End Structure

    Public Enum ShellEvents
        HSHELL_WINDOWCREATED = 1
        HSHELL_WINDOWDESTROYED = 2
        HSHELL_ACTIVATESHELLWINDOW = 3
        HSHELL_WINDOWACTIVATED = 4
        HSHELL_GETMINRECT = 5
        HSHELL_REDRAW = 6
        HSHELL_TASKMAN = 7
        HSHELL_LANGUAGE = 8
        HSHELL_ACCESSIBILITYSTATE = 11
    End Enum




#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Timer1 As System.Windows.Forms.Timer
    Friend WithEvents butRefreshProc As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents chkActivateScreenSaver As System.Windows.Forms.CheckBox
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    Friend WithEvents animhelper As System.Windows.Forms.Timer
    Friend WithEvents runButton As System.Windows.Forms.Button
    Friend WithEvents chkCloseOnTimeout As System.Windows.Forms.CheckBox



    Friend WithEvents Processes As System.Windows.Forms.TabPage
    Friend WithEvents Applications As System.Windows.Forms.TabPage
    Friend WithEvents TabControl1 As System.Windows.Forms.TabControl
    Friend WithEvents chkKillProcess As System.Windows.Forms.CheckBox
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents WindowTitle As System.Windows.Forms.ColumnHeader
    Friend WithEvents WindowClass As System.Windows.Forms.ColumnHeader
    Friend WithEvents lvWindow As System.Windows.Forms.ListView


    Friend WithEvents txtTime As System.Windows.Forms.TextBox
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    Friend WithEvents scrollSec As System.Windows.Forms.VScrollBar
    Friend WithEvents scrollMin As System.Windows.Forms.VScrollBar
    Friend WithEvents scrollHour As System.Windows.Forms.VScrollBar
    Friend WithEvents About As System.Windows.Forms.MenuItem
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents radNone As System.Windows.Forms.RadioButton
    Friend WithEvents radLogoff As System.Windows.Forms.RadioButton
    Friend WithEvents radRestart As System.Windows.Forms.RadioButton
    Friend WithEvents radShutdown As System.Windows.Forms.RadioButton
    Friend WithEvents txtConfirm As System.Windows.Forms.TextBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents chkForce As System.Windows.Forms.CheckBox
    Friend WithEvents menuMinimizeTray As System.Windows.Forms.MenuItem
    Friend WithEvents menuOption As System.Windows.Forms.MenuItem
    Friend WithEvents panelSystem As System.Windows.Forms.Panel
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents cmNotify As System.Windows.Forms.ContextMenu
    Friend WithEvents miQuit As System.Windows.Forms.MenuItem
    Friend WithEvents muStartStop As System.Windows.Forms.MenuItem
    Friend WithEvents ProcName As System.Windows.Forms.ColumnHeader
    Friend WithEvents PID As System.Windows.Forms.ColumnHeader
    Friend WithEvents lvProcess As System.Windows.Forms.ListView
    Friend WithEvents moduleName As System.Windows.Forms.ColumnHeader
    Friend WithEvents lblNumWin As System.Windows.Forms.Label
    Friend WithEvents lblNumProc As System.Windows.Forms.Label



    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.runButton = New System.Windows.Forms.Button()
        Me.Timer1 = New System.Windows.Forms.Timer(Me.components)
        Me.butRefreshProc = New System.Windows.Forms.Button()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.chkActivateScreenSaver = New System.Windows.Forms.CheckBox()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        Me.animhelper = New System.Windows.Forms.Timer(Me.components)
        Me.chkCloseOnTimeout = New System.Windows.Forms.CheckBox()
        Me.TabControl1 = New System.Windows.Forms.TabControl()
        Me.Applications = New System.Windows.Forms.TabPage()
        Me.butAppSelectNone = New System.Windows.Forms.Button()
        Me.lblNumWin = New System.Windows.Forms.Label()
        Me.lvWindow = New System.Windows.Forms.ListView()
        Me.windowCheck = New System.Windows.Forms.ColumnHeader()
        Me.WindowTitle = New System.Windows.Forms.ColumnHeader()
        Me.WindowClass = New System.Windows.Forms.ColumnHeader()
        Me.Processes = New System.Windows.Forms.TabPage()
        Me.butProcessSelectNone = New System.Windows.Forms.Button()
        Me.lblNumProc = New System.Windows.Forms.Label()
        Me.lvProcess = New System.Windows.Forms.ListView()
        Me.ProcessCheck = New System.Windows.Forms.ColumnHeader()
        Me.PID = New System.Windows.Forms.ColumnHeader()
        Me.ProcName = New System.Windows.Forms.ColumnHeader()
        Me.moduleName = New System.Windows.Forms.ColumnHeader()
        Me.chkShowAllUser = New System.Windows.Forms.CheckBox()
        Me.chkKillProcess = New System.Windows.Forms.CheckBox()
        Me.TabPage1 = New System.Windows.Forms.TabPage()
        Me.panelSystem = New System.Windows.Forms.Panel()
        Me.chkForce = New System.Windows.Forms.CheckBox()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.txtConfirm = New System.Windows.Forms.TextBox()
        Me.radShutdown = New System.Windows.Forms.RadioButton()
        Me.radRestart = New System.Windows.Forms.RadioButton()
        Me.radLogoff = New System.Windows.Forms.RadioButton()
        Me.radNone = New System.Windows.Forms.RadioButton()
        Me.txtTime = New System.Windows.Forms.TextBox()
        Me.scrollHour = New System.Windows.Forms.VScrollBar()
        Me.scrollMin = New System.Windows.Forms.VScrollBar()
        Me.scrollSec = New System.Windows.Forms.VScrollBar()
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.MainMenu1 = New System.Windows.Forms.MainMenu()
        Me.menuOption = New System.Windows.Forms.MenuItem()
        Me.menuMinimizeTray = New System.Windows.Forms.MenuItem()
        Me.About = New System.Windows.Forms.MenuItem()
        Me.MenuItem1 = New System.Windows.Forms.MenuItem()
        Me.MenuItem2 = New System.Windows.Forms.MenuItem()
        Me.NotifyIcon1 = New System.Windows.Forms.NotifyIcon(Me.components)
        Me.cmNotify = New System.Windows.Forms.ContextMenu()
        Me.muStartStop = New System.Windows.Forms.MenuItem()
        Me.MenuItem4 = New System.Windows.Forms.MenuItem()
        Me.miQuit = New System.Windows.Forms.MenuItem()
        Me.chkDynamicUpdateList = New System.Windows.Forms.CheckBox()
        Me.TabControl1.SuspendLayout()
        Me.Applications.SuspendLayout()
        Me.Processes.SuspendLayout()
        Me.TabPage1.SuspendLayout()
        Me.panelSystem.SuspendLayout()
        Me.SuspendLayout()
        '
        'runButton
        '
        Me.runButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 14.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.runButton.Location = New System.Drawing.Point(40, 16)
        Me.runButton.Name = "runButton"
        Me.runButton.Size = New System.Drawing.Size(128, 48)
        Me.runButton.TabIndex = 0
        Me.runButton.Text = "Start"
        '
        'Timer1
        '
        Me.Timer1.Interval = 1000
        '
        'butRefreshProc
        '
        Me.butRefreshProc.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me.butRefreshProc.Location = New System.Drawing.Point(424, 296)
        Me.butRefreshProc.Name = "butRefreshProc"
        Me.butRefreshProc.Size = New System.Drawing.Size(88, 24)
        Me.butRefreshProc.TabIndex = 5
        Me.butRefreshProc.Text = "Refresh Lists"
        Me.ToolTip1.SetToolTip(Me.butRefreshProc, "Refresh Application and Process list")
        '
        'Label1
        '
        Me.Label1.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.Label1.Location = New System.Drawing.Point(16, 304)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(400, 16)
        Me.Label1.TabIndex = 6
        Me.Label1.Text = "Label1"
        '
        'chkActivateScreenSaver
        '
        Me.chkActivateScreenSaver.Checked = True
        Me.chkActivateScreenSaver.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkActivateScreenSaver.Location = New System.Drawing.Point(352, 32)
        Me.chkActivateScreenSaver.Name = "chkActivateScreenSaver"
        Me.chkActivateScreenSaver.Size = New System.Drawing.Size(160, 24)
        Me.chkActivateScreenSaver.TabIndex = 7
        Me.chkActivateScreenSaver.Text = "Activate ScreenSaver"
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.ProgressBar1.Location = New System.Drawing.Point(0, 329)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(520, 16)
        Me.ProgressBar1.Step = 1
        Me.ProgressBar1.TabIndex = 8
        Me.ProgressBar1.Value = 100
        '
        'animhelper
        '
        Me.animhelper.Interval = 200
        '
        'chkCloseOnTimeout
        '
        Me.chkCloseOnTimeout.Checked = True
        Me.chkCloseOnTimeout.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkCloseOnTimeout.Location = New System.Drawing.Point(352, 56)
        Me.chkCloseOnTimeout.Name = "chkCloseOnTimeout"
        Me.chkCloseOnTimeout.Size = New System.Drawing.Size(160, 24)
        Me.chkCloseOnTimeout.TabIndex = 11
        Me.chkCloseOnTimeout.Text = "Self-close on Timeout"
        '
        'TabControl1
        '
        Me.TabControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.TabControl1.Controls.AddRange(New System.Windows.Forms.Control() {Me.Applications, Me.Processes, Me.TabPage1})
        Me.TabControl1.Location = New System.Drawing.Point(8, 80)
        Me.TabControl1.Name = "TabControl1"
        Me.TabControl1.SelectedIndex = 0
        Me.TabControl1.Size = New System.Drawing.Size(504, 208)
        Me.TabControl1.TabIndex = 13
        '
        'Applications
        '
        Me.Applications.Controls.AddRange(New System.Windows.Forms.Control() {Me.butAppSelectNone, Me.lblNumWin, Me.lvWindow})
        Me.Applications.Location = New System.Drawing.Point(4, 22)
        Me.Applications.Name = "Applications"
        Me.Applications.Size = New System.Drawing.Size(496, 182)
        Me.Applications.TabIndex = 0
        Me.Applications.Text = "Applications"
        '
        'butAppSelectNone
        '
        Me.butAppSelectNone.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left)
        Me.butAppSelectNone.Font = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.butAppSelectNone.Location = New System.Drawing.Point(96, 162)
        Me.butAppSelectNone.Name = "butAppSelectNone"
        Me.butAppSelectNone.Size = New System.Drawing.Size(64, 16)
        Me.butAppSelectNone.TabIndex = 19
        Me.butAppSelectNone.Text = "Select None"
        '
        'lblNumWin
        '
        Me.lblNumWin.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left)
        Me.lblNumWin.Location = New System.Drawing.Point(8, 164)
        Me.lblNumWin.Name = "lblNumWin"
        Me.lblNumWin.Size = New System.Drawing.Size(88, 16)
        Me.lblNumWin.TabIndex = 18
        Me.lblNumWin.Text = "numWin"
        '
        'lvWindow
        '
        Me.lvWindow.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.lvWindow.BackColor = System.Drawing.SystemColors.Window
        Me.lvWindow.CheckBoxes = True
        Me.lvWindow.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.windowCheck, Me.WindowTitle, Me.WindowClass})
        Me.lvWindow.GridLines = True
        Me.lvWindow.Name = "lvWindow"
        Me.lvWindow.Size = New System.Drawing.Size(496, 160)
        Me.lvWindow.TabIndex = 17
        Me.lvWindow.View = System.Windows.Forms.View.Details
        '
        'windowCheck
        '
        Me.windowCheck.Text = ""
        Me.windowCheck.Width = 20
        '
        'WindowTitle
        '
        Me.WindowTitle.Text = "Window Title"
        Me.WindowTitle.Width = 250
        '
        'WindowClass
        '
        Me.WindowClass.Text = "Class"
        Me.WindowClass.Width = 220
        '
        'Processes
        '
        Me.Processes.Controls.AddRange(New System.Windows.Forms.Control() {Me.butProcessSelectNone, Me.lblNumProc, Me.lvProcess, Me.chkShowAllUser, Me.chkKillProcess})
        Me.Processes.Location = New System.Drawing.Point(4, 22)
        Me.Processes.Name = "Processes"
        Me.Processes.Size = New System.Drawing.Size(496, 162)
        Me.Processes.TabIndex = 1
        Me.Processes.Text = "Processes"
        '
        'butProcessSelectNone
        '
        Me.butProcessSelectNone.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left)
        Me.butProcessSelectNone.Font = New System.Drawing.Font("Microsoft Sans Serif", 6.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.butProcessSelectNone.Location = New System.Drawing.Point(96, 142)
        Me.butProcessSelectNone.Name = "butProcessSelectNone"
        Me.butProcessSelectNone.Size = New System.Drawing.Size(64, 16)
        Me.butProcessSelectNone.TabIndex = 20
        Me.butProcessSelectNone.Text = "Select None"
        '
        'lblNumProc
        '
        Me.lblNumProc.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left)
        Me.lblNumProc.Location = New System.Drawing.Point(8, 144)
        Me.lblNumProc.Name = "lblNumProc"
        Me.lblNumProc.Size = New System.Drawing.Size(88, 16)
        Me.lblNumProc.TabIndex = 17
        Me.lblNumProc.Text = "numProc"
        '
        'lvProcess
        '
        Me.lvProcess.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.lvProcess.CheckBoxes = True
        Me.lvProcess.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ProcessCheck, Me.PID, Me.ProcName, Me.moduleName})
        Me.lvProcess.GridLines = True
        Me.lvProcess.Name = "lvProcess"
        Me.lvProcess.Size = New System.Drawing.Size(496, 140)
        Me.lvProcess.TabIndex = 16
        Me.lvProcess.View = System.Windows.Forms.View.Details
        '
        'ProcessCheck
        '
        Me.ProcessCheck.Text = ""
        Me.ProcessCheck.Width = 20
        '
        'PID
        '
        Me.PID.Text = "PID"
        Me.PID.Width = 70
        '
        'ProcName
        '
        Me.ProcName.Text = "Process Name"
        Me.ProcName.Width = 150
        '
        'moduleName
        '
        Me.moduleName.Text = "Module Name"
        Me.moduleName.Width = 255
        '
        'chkShowAllUser
        '
        Me.chkShowAllUser.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me.chkShowAllUser.Location = New System.Drawing.Point(272, 144)
        Me.chkShowAllUser.Name = "chkShowAllUser"
        Me.chkShowAllUser.Size = New System.Drawing.Size(128, 16)
        Me.chkShowAllUser.TabIndex = 15
        Me.chkShowAllUser.Text = "Show From All Users"
        Me.chkShowAllUser.Visible = False
        '
        'chkKillProcess
        '
        Me.chkKillProcess.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me.chkKillProcess.Location = New System.Drawing.Point(408, 144)
        Me.chkKillProcess.Name = "chkKillProcess"
        Me.chkKillProcess.Size = New System.Drawing.Size(96, 16)
        Me.chkKillProcess.TabIndex = 14
        Me.chkKillProcess.Text = "KILL process"
        '
        'TabPage1
        '
        Me.TabPage1.Controls.AddRange(New System.Windows.Forms.Control() {Me.panelSystem})
        Me.TabPage1.Location = New System.Drawing.Point(4, 22)
        Me.TabPage1.Name = "TabPage1"
        Me.TabPage1.Size = New System.Drawing.Size(496, 162)
        Me.TabPage1.TabIndex = 2
        Me.TabPage1.Text = "System"
        '
        'panelSystem
        '
        Me.panelSystem.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.panelSystem.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.panelSystem.Controls.AddRange(New System.Windows.Forms.Control() {Me.chkForce, Me.Label2, Me.txtConfirm, Me.radShutdown, Me.radRestart, Me.radLogoff, Me.radNone})
        Me.panelSystem.Name = "panelSystem"
        Me.panelSystem.Size = New System.Drawing.Size(496, 164)
        Me.panelSystem.TabIndex = 7
        '
        'chkForce
        '
        Me.chkForce.Enabled = False
        Me.chkForce.Location = New System.Drawing.Point(70, 122)
        Me.chkForce.Name = "chkForce"
        Me.chkForce.Size = New System.Drawing.Size(120, 24)
        Me.chkForce.TabIndex = 13
        Me.chkForce.Text = "FORCEIFHUNG"
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.Location = New System.Drawing.Point(238, 42)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(184, 23)
        Me.Label2.TabIndex = 12
        Me.Label2.Text = "Type CONFIRM below"
        '
        'txtConfirm
        '
        Me.txtConfirm.Location = New System.Drawing.Point(270, 74)
        Me.txtConfirm.Name = "txtConfirm"
        Me.txtConfirm.Size = New System.Drawing.Size(112, 20)
        Me.txtConfirm.TabIndex = 11
        Me.txtConfirm.Text = ""
        '
        'radShutdown
        '
        Me.radShutdown.Enabled = False
        Me.radShutdown.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.radShutdown.Location = New System.Drawing.Point(70, 90)
        Me.radShutdown.Name = "radShutdown"
        Me.radShutdown.TabIndex = 10
        Me.radShutdown.Text = "Shutdown"
        '
        'radRestart
        '
        Me.radRestart.Enabled = False
        Me.radRestart.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.radRestart.Location = New System.Drawing.Point(70, 66)
        Me.radRestart.Name = "radRestart"
        Me.radRestart.TabIndex = 9
        Me.radRestart.Text = "Restart"
        '
        'radLogoff
        '
        Me.radLogoff.Enabled = False
        Me.radLogoff.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.radLogoff.Location = New System.Drawing.Point(70, 42)
        Me.radLogoff.Name = "radLogoff"
        Me.radLogoff.TabIndex = 8
        Me.radLogoff.Text = "Log Off"
        '
        'radNone
        '
        Me.radNone.Checked = True
        Me.radNone.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.radNone.Location = New System.Drawing.Point(70, 18)
        Me.radNone.Name = "radNone"
        Me.radNone.TabIndex = 7
        Me.radNone.TabStop = True
        Me.radNone.Text = "No Action"
        '
        'txtTime
        '
        Me.txtTime.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtTime.Location = New System.Drawing.Point(192, 24)
        Me.txtTime.Name = "txtTime"
        Me.txtTime.Size = New System.Drawing.Size(88, 26)
        Me.txtTime.TabIndex = 18
        Me.txtTime.Text = "00:00:00"
        Me.txtTime.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'scrollHour
        '
        Me.scrollHour.Location = New System.Drawing.Point(280, 24)
        Me.scrollHour.Name = "scrollHour"
        Me.scrollHour.Size = New System.Drawing.Size(16, 24)
        Me.scrollHour.TabIndex = 19
        Me.ToolTip1.SetToolTip(Me.scrollHour, "Increment or decrement hours")
        '
        'scrollMin
        '
        Me.scrollMin.Location = New System.Drawing.Point(296, 24)
        Me.scrollMin.Name = "scrollMin"
        Me.scrollMin.Size = New System.Drawing.Size(16, 24)
        Me.scrollMin.TabIndex = 20
        Me.ToolTip1.SetToolTip(Me.scrollMin, "Increment or decrement minutes")
        '
        'scrollSec
        '
        Me.scrollSec.Location = New System.Drawing.Point(312, 24)
        Me.scrollSec.Name = "scrollSec"
        Me.scrollSec.Size = New System.Drawing.Size(16, 24)
        Me.scrollSec.TabIndex = 21
        Me.ToolTip1.SetToolTip(Me.scrollSec, "Increment or decrement seconds")
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuOption, Me.About})
        '
        'menuOption
        '
        Me.menuOption.Index = 0
        Me.menuOption.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.menuMinimizeTray})
        Me.menuOption.Text = "Options"
        '
        'menuMinimizeTray
        '
        Me.menuMinimizeTray.Index = 0
        Me.menuMinimizeTray.Text = "Minimize to Tray"
        '
        'About
        '
        Me.About.Index = 1
        Me.About.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1, Me.MenuItem2})
        Me.About.Text = "Help"
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.Text = "About"
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 1
        Me.MenuItem2.Text = "Command Line Info"
        '
        'NotifyIcon1
        '
        Me.NotifyIcon1.ContextMenu = Me.cmNotify
        Me.NotifyIcon1.Icon = CType(resources.GetObject("NotifyIcon1.Icon"), System.Drawing.Icon)
        Me.NotifyIcon1.Text = "Timed Shut Down"
        '
        'cmNotify
        '
        Me.cmNotify.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.muStartStop, Me.MenuItem4, Me.miQuit})
        '
        'muStartStop
        '
        Me.muStartStop.Index = 0
        Me.muStartStop.Text = "Start"
        '
        'MenuItem4
        '
        Me.MenuItem4.Index = 1
        Me.MenuItem4.Text = "-"
        '
        'miQuit
        '
        Me.miQuit.Index = 2
        Me.miQuit.Text = "Quit"
        '
        'chkDynamicUpdateList
        '
        Me.chkDynamicUpdateList.Checked = True
        Me.chkDynamicUpdateList.CheckState = System.Windows.Forms.CheckState.Checked
        Me.chkDynamicUpdateList.Location = New System.Drawing.Point(352, 8)
        Me.chkDynamicUpdateList.Name = "chkDynamicUpdateList"
        Me.chkDynamicUpdateList.Size = New System.Drawing.Size(160, 24)
        Me.chkDynamicUpdateList.TabIndex = 22
        Me.chkDynamicUpdateList.Text = "Dynamic Update Lists"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(520, 345)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.chkDynamicUpdateList, Me.scrollSec, Me.scrollMin, Me.txtTime, Me.TabControl1, Me.chkCloseOnTimeout, Me.ProgressBar1, Me.chkActivateScreenSaver, Me.Label1, Me.butRefreshProc, Me.runButton, Me.scrollHour})
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.Menu = Me.MainMenu1
        Me.MinimumSize = New System.Drawing.Size(528, 392)
        Me.Name = "Form1"
        Me.Text = "Timed Shutdown"
        Me.TabControl1.ResumeLayout(False)
        Me.Applications.ResumeLayout(False)
        Me.Processes.ResumeLayout(False)
        Me.TabPage1.ResumeLayout(False)
        Me.panelSystem.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Structure ColumnSorter
        Dim m_SortingColumn As ColumnHeader
        Dim m_SortingStyle As SortOrder
    End Structure

    Private m_ProcessSortingColumn As ColumnSorter
    Private m_WindowSortingColumn As ColumnSorter

    Dim origtime As Integer
    Dim cycleCol As Boolean = False


    Dim startNow As Boolean = False

    Dim normalIcon As Icon
    Dim animIcon1 As Icon
    Dim animIcon2 As Icon
    Dim animIcon3 As Icon
    Dim animIcon4 As Icon
    Dim animIcon5 As Icon
    Dim animIcon6 As Icon
    Dim animIcon7 As Icon
    Dim animIcon8 As Icon
    Dim iconList As ArrayList
    Dim iconListIndex As Integer

    Private Sub handleToggle()
        If (Timer1.Enabled = False) Then
            turnOn()
        Else
            turnOff()
        End If

    End Sub

    Private Sub turnOn()
        If Not timeValid(txtTime.Text) Then
            MessageBox.Show("Cannot parse time, valid formats are h*:mm:ss, m*:ss and s*", "Parse Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        Me.runButton.BackColor = System.Drawing.SystemColors.Control
        Me.lvProcess.BackColor = System.Drawing.SystemColors.InactiveBorder
        Me.lvWindow.BackColor = System.Drawing.SystemColors.InactiveBorder

        Timer1.Enabled = True
        Me.txtTime.ReadOnly = True
        Me.panelSystem.Enabled = False
        Me.scrollHour.Enabled = False
        Me.scrollMin.Enabled = False
        Me.scrollSec.Enabled = False
        Me.runButton.Text = "Stop"
        Me.lvProcess.SelectedItems.Clear()
        Me.lvWindow.SelectedItems.Clear()
        Me.butAppSelectNone.Enabled = False
        Me.butProcessSelectNone.Enabled = False
        Me.chkKillProcess.Enabled = False
        Me.chkActivateScreenSaver.Enabled = False
        Me.chkCloseOnTimeout.Enabled = False
        Me.butRefreshProc.Enabled = False
        Me.animhelper.Enabled = True
        origtime = getTime()
        Me.ProgressBar1.Value = 100
        Me.NotifyIcon1.Text = "Timed Shutdown - Running"
        Me.cmNotify.MenuItems.Item(0).Text = "Stop"
    End Sub


    Private Sub turnOff()
        Me.runButton.BackColor = System.Drawing.SystemColors.Control
        Me.lvProcess.BackColor = System.Drawing.SystemColors.Window
        Me.lvWindow.BackColor = System.Drawing.SystemColors.Window
        Timer1.Enabled = False
        Me.txtTime.ReadOnly = False
        Me.panelSystem.Enabled = True
        Me.scrollHour.Enabled = True
        Me.scrollMin.Enabled = True
        Me.scrollSec.Enabled = True

        Me.runButton.Text = "Start"

        Me.butAppSelectNone.Enabled = True
        Me.butProcessSelectNone.Enabled = True
        Me.chkKillProcess.Enabled = True
        Me.chkActivateScreenSaver.Enabled = True
        Me.chkCloseOnTimeout.Enabled = True
        Me.butRefreshProc.Enabled = True
        Me.animhelper.Enabled = False
        Me.runButton.BackColor = System.Drawing.SystemColors.Control
        Me.NotifyIcon1.Text = "Timed Shutdown - Stopped"
        Me.Icon = Me.normalIcon
        Me.NotifyIcon1.Icon = Me.animIcon5
        Me.iconListIndex = 0
        Me.cmNotify.MenuItems.Item(0).Text = "Start"
    End Sub







    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles runButton.Click
        handleToggle()
    End Sub


    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim totalTime As Integer
        totalTime = Me.getTime()
        totalTime = totalTime - 1
        If (origtime > 0) Then Me.ProgressBar1.Value = CInt((CDbl(totalTime) / CDbl(origtime)) * 100)

        If (totalTime <= 0) Then
            fire()
            Timer1.Enabled = False
            totalTime = 0
        End If

        setTime(totalTime)
        Me.NotifyIcon1.Text = "Timed Shutdown - Running [" + Me.txtTime.Text + "]"
    End Sub




    Private Sub fire()
        Me.Timer1.Enabled = False

        Dim i As Integer
        For i = 1 To Me.lvProcess.CheckedIndices.Count
            Dim index As Integer = Me.lvProcess.CheckedIndices.Item(i - i)
            Dim lvProcItem As ProcessListViewItem = DirectCast(lvProcess.Items(index), ProcessListViewItem)
            If (Me.chkKillProcess.Checked = True) Then
                lvProcItem.proc.Kill()
            Else
                lvProcItem.proc.CloseMainWindow()
            End If
        Next

        For i = 1 To Me.lvWindow.CheckedIndices.Count
            Dim index As Integer = Me.lvWindow.CheckedIndices.Item(i - 1)
            Dim lvWndItem As WindowListViewItem = DirectCast(lvWindow.Items(index), WindowListViewItem)
            Dim hwnd As Integer = lvWndItem.apphwnd
            SendMessage(hwnd, WM_CLOSE, 0, 0)
            'MsgBox("about to close " + CStr(hwnd))
        Next


        If (Me.chkActivateScreenSaver.Checked = True) Then Me.activateScreenSaver()


        'HANDLE SYSTEM EVENTS

        Dim flags As Integer = 0
        If Me.chkForce.Checked = True Then flags = Me.EWX_FORCEIFHUNG

        If Me.radLogoff.Checked = True Then
            AdjustToken()
            ExitWindowsEx(EWX_LOGOFF Or flags, 0)
        End If
        If Me.radRestart.Checked = True Then
            AdjustToken()
            ExitWindowsEx(EWX_RESTART Or flags, 0)
        End If
        If Me.radShutdown.Checked = True Then
            AdjustToken()
            ExitWindowsEx(EWX_POWEROFF Or flags, 0)
        End If


        If (Me.chkCloseOnTimeout.Checked = True) Then
            Me.NotifyIcon1.Visible = False
            Application.Exit()
        Else
            turnOff()
            refreshApp()
        End If

    End Sub

    'DISABLE THIS FOR THE MOMENT
    Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
        If m.Msg = uMsgNotify Then
            Select Case m.WParam.ToInt32
                Case ShellEvents.HSHELL_WINDOWCREATED
                    'Debug.WriteLine("window activated")
                    If chkDynamicUpdateList.Checked = True Then refreshApp()
                Case ShellEvents.HSHELL_WINDOWDESTROYED
                    'Debug.WriteLine("window destroyed")
                    If chkDynamicUpdateList.Checked = True Then refreshApp()

            End Select
        End If

        MyBase.WndProc(m)
    End Sub


    Private Function getEmbeddedIcon(ByVal iconName As String) As Icon
        Dim picture_stream As System.IO.Stream
        Dim executing_assembly As System.Reflection.Assembly = Me.GetType.Assembly.GetEntryAssembly()

        ' Get our namespace.
        Dim my_namespace As String = executing_assembly.GetName().Name.ToString()

        picture_stream = executing_assembly.GetManifestResourceStream(my_namespace + "." + iconName)
        Dim newIcon As Icon

        If Not (picture_stream Is Nothing) Then
            newIcon = New Icon(picture_stream)
            picture_stream.Close()
        End If
        Return newIcon
    End Function

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'DISABLE THIS FOR THE MOMENT
        ' This will register the ShellHook event messages between the shell and our application.
        ' The uMsgNotify is then used to communicate between the shell and our application whenever any
        ' of the shell events are fired such as an app starting up, shutting down, activating, minimizing, etc
        uMsgNotify = RegisterWindowMessage("SHELLHOOK")
        ' This basically registers our window to receive the shell events
        Call RegisterShellHookWindow(Me.Handle)


        'Me.SetStyle(ControlStyles.AllPaintingInWmPaint Or ControlStyles.DoubleBuffer Or ControlStyles.ResizeRedraw Or ControlStyles.UserPaint, True)
        'Me.UpdateStyles()


        loadprocs()
        loadwind()
        Me.handleCommandline()

        Me.Label1.Text = CStr(lvProcess.SelectedItems.Count) + " Process(es) and " + CStr(lvWindow.SelectedItems.Count) + " Window(s) Selected"
        If Me.radLogoff.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Log Off"
        If Me.radRestart.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Restart"
        If Me.radShutdown.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Shut Down"


        normalIcon = getEmbeddedIcon("timedshutdown.ico")
        animIcon1 = getEmbeddedIcon("anim1.ico")
        animIcon2 = getEmbeddedIcon("anim2.ico")
        animIcon3 = getEmbeddedIcon("anim3.ico")
        animIcon4 = getEmbeddedIcon("anim4.ico")
        animIcon5 = getEmbeddedIcon("anim5.ico")
        animIcon6 = getEmbeddedIcon("anim6.ico")
        animIcon7 = getEmbeddedIcon("anim7.ico")
        animIcon8 = getEmbeddedIcon("anim8.ico")

        iconList = New ArrayList()
        iconList.Add(animIcon1)
        iconList.Add(animIcon1)
        iconList.Add(animIcon2)
        iconList.Add(animIcon2)
        iconList.Add(animIcon3)
        iconList.Add(animIcon3)
        iconList.Add(animIcon4)
        iconList.Add(animIcon4)
        iconList.Add(animIcon5)
        iconList.Add(animIcon5)
        iconList.Add(animIcon6)
        iconList.Add(animIcon7)
        iconList.Add(animIcon8)
        iconListIndex = 0

        Me.NotifyIcon1.Text = "Timed Shutdown - Stopped"
        Me.NotifyIcon1.Icon = animIcon5



    End Sub

    Private Sub loadprocs()

        Dim processIDArray As New ArrayList()
        Dim processCheck As New ArrayList()
        Dim procItem As ProcessListViewItem
        For Each procItem In lvProcess.Items
            processIDArray.Add(procItem.proc.Id)
        Next



        Dim proc As Process
        Dim lvProcessItems As ListView.ListViewItemCollection = lvProcess.Items


        lvProcess.BeginUpdate()

        For Each proc In Process.GetProcesses


            Dim procID As Integer = proc.Id
            processCheck.Add(procID)

            If processIDArray.IndexOf(procID) = -1 Then

                Dim procName As String = ""
                Dim procMainModuleName As String = ""
                Dim pid As String = ""

                procName = proc.ProcessName
                procMainModuleName = ""
                pid = ""

                Try
                    If Not proc.MainModule Is Nothing Then
                        If Not proc.MainModule.ModuleName Is Nothing Then
                            procMainModuleName = proc.MainModule.ModuleName
                        End If
                    End If

                    pid = proc.Id.ToString
                Catch
                    'must not have access to this process, don't use it
                    procMainModuleName = ""
                    pid = ""

                End Try



                'TODO here
                '           MsgBox(proc.StartInfo.EnvironmentVariables.Item("UserName"))
                '            Environment.UserName()

                Dim fullEntryName As String = "(" + pid + ")  " + procName + " - " + procMainModuleName





                'If (proc.MainWindowHandle.ToInt64 > 0) Then
                If Not (procMainModuleName = "") Then
                    ' If Me.chkShowAllUser.Checked = False Then
                    ' If proc.StartInfo.EnvironmentVariables.Item("UserName") = Environment.UserName Then
                    '    Me.chklistProcess.Items.Add(fullEntryName)
                    '    proclist.Add(proc)
                    'End If
                    'Else

                    Dim procLVItem As New ProcessListViewItem(proc)
                    lvProcess.Items.Add(procLVItem)


                    'End If
                End If


                'Me.chklistProcess.Items.Add(proc.ProcessName)
                'proclist.Add(proc)
            End If
        Next


        Dim checkProc As Integer
        Dim lvProcessItem As ProcessListViewItem
        For Each checkProc In processIDArray
            'if we can't find a previous entry in the entry of all existing windows, remove it
            If processCheck.IndexOf(checkProc) = -1 Then
                For Each lvProcessItem In lvProcess.Items
                    If lvProcessItem.proc.Id = checkProc Then
                        lvProcessItem.Checked = False
                        lvProcess.Items.Remove(lvProcessItem)
                    End If
                Next
            End If
        Next

        lvProcess.EndUpdate()


        Me.lblNumProc.Text = Me.lvProcess.Items.Count.ToString + " Process(es)"
    End Sub

    Private Sub loadwind()
        Dim windowIDArray As New ArrayList()
        Dim windowCheck As New ArrayList()



        Dim winItem As WindowListViewItem
        For Each winItem In lvWindow.Items
            windowIDArray.Add(winItem.apphwnd)
        Next

        'Me.lvWindow.Items.Clear()

        Dim app_hwnd As Integer
        Dim app_parent As Integer
        Dim app_owner As Integer
        Dim app_visible As Boolean
        Dim app_style As Integer
        Dim app_text As String
        Dim app_class As String


        GetWindowInfo(app_hwnd, app_parent, app_owner, app_visible, app_style, app_text, app_class)

        app_hwnd = GetTopWindow(0)

        lvWindow.BeginUpdate()

        Do While app_hwnd <> 0

            windowCheck.Add(app_hwnd)

            'if the current hwnd isn't in our list, add it
            If windowIDArray.IndexOf(app_hwnd) = -1 Then
                ' Get information about this window.
                GetWindowInfo(app_hwnd, app_parent, app_owner, app_visible, app_style, app_text, app_class)

                ' See if this window is interesting.
                If app_visible And app_parent = 0 And app_owner = 0 And Len(app_text) > 0 And _
                    (Microsoft.VisualBasic.Left(app_class, 7) <> "Progman" Or (app_style And WS_OVERLAPPEDWINDOW) <> 0) _
                    Then
                    Dim windowLVItem As New WindowListViewItem(app_hwnd, app_text, app_class)
                    If windowIDArray.IndexOf(app_hwnd) > -1 Then windowLVItem.Checked = True
                    Me.lvWindow.Items.Add(windowLVItem)

                End If
            End If
            app_hwnd = GetNextWindow(app_hwnd, GW_HWNDNEXT)
        Loop

        Dim checkWnd As Integer
        Dim lvWindowItem As WindowListViewItem


        For Each checkWnd In windowIDArray
            'if we can't find a previous entry in the entry of all existing windows, remove it
            If windowCheck.IndexOf(checkWnd) = -1 Then
                For Each lvWindowItem In lvWindow.Items
                    If lvWindowItem.apphwnd = checkWnd Then
                        lvWindowItem.Checked = False
                        lvWindow.Items.Remove(lvWindowItem)
                    End If
                Next
            End If
        Next

        lvWindow.EndUpdate()

        Me.lblNumWin.Text = Me.lvWindow.Items.Count.ToString + " Window(s)"

    End Sub

    Private Sub refreshApp()


        loadprocs()
        loadwind()


        Me.Label1.Text = CStr(Me.lvProcess.CheckedItems.Count) + " Process(es) and " + CStr(Me.lvWindow.CheckedItems.Count) + " Window(s) Selected"
        If Me.radLogoff.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Log Off"
        If Me.radRestart.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Restart"
        If Me.radShutdown.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Shut Down"

    End Sub

    Private Sub butRefreshProc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butRefreshProc.Click
        CType(sender, Button).Enabled = False
        'hard refresh
        Dim winItem As WindowListViewItem
        Dim winCheckedHWND As New ArrayList()
        For Each winItem In lvWindow.CheckedItems
            winCheckedHWND.Add(winItem.apphwnd)
        Next

        Dim procItem As ProcessListViewItem
        Dim procCheckedID As New ArrayList()
        For Each procItem In lvProcess.CheckedItems
            procCheckedID.Add(procItem.proc.Id)
        Next

        lvWindow.Items.Clear()
        lvProcess.Items.Clear()
        refreshApp()

        For Each winItem In lvWindow.Items
            If winCheckedHWND.IndexOf(winItem.apphwnd) <> -1 Then winItem.Checked = True
        Next
        For Each procItem In lvProcess.Items
            If procCheckedID.IndexOf(procItem.proc.Id) <> -1 Then procItem.Checked = True
        Next

        CType(sender, Button).Enabled = True
    End Sub






    Private Sub activateScreenSaver()
        Const WM_SYSCOMMAND As Integer = &H112&
        Const SC_SCREENSAVE As Integer = &HF140&
        Dim result As Long
        result = SendMessage(Me.Handle.ToInt32, WM_SYSCOMMAND, SC_SCREENSAVE, 0&)
    End Sub




    Private Sub animhelper_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles animhelper.Tick

        If Me.cycleCol = True Then
            Me.cycleCol = False
            Me.runButton.BackColor = System.Drawing.SystemColors.Control
        Else
            Me.cycleCol = True
            Me.runButton.BackColor = System.Drawing.Color.Chartreuse
        End If

        If Me.Timer1.Enabled = True Then
            iconListIndex = iconListIndex + 1
            If iconListIndex > iconList.Count - 1 Then
                iconListIndex = 0
            End If
            If Me.NotifyIcon1.Visible = True Then
                Me.NotifyIcon1.Icon = DirectCast(iconList.Item(iconListIndex), System.Drawing.Icon)
            End If
            Me.Icon = DirectCast(iconList.Item(iconListIndex), System.Drawing.Icon)
        End If
    End Sub






    ' Return information about this window.
    Private Sub GetWindowInfo(ByVal app_hwnd As Integer, ByRef app_parent As Integer, ByRef app_owner As Integer, ByRef app_visible As Boolean, ByRef app_style As Integer, ByRef app_text As String, ByRef app_class As String)
        Const MAX_LENGTH As Integer = 1024

        Dim buf As String
        buf = Space(MAX_LENGTH)
        Dim length As Integer

        app_parent = GetParent(app_hwnd)
        app_owner = GetWindowLong(app_hwnd, GWL_HWNDPARENT)
        Dim isVisible As Integer = IsWindowVisible(app_hwnd)
        app_visible = CBool(isVisible)
        app_style = GetWindowLong(app_hwnd, GWL_STYLE)

        length = GetWindowText(app_hwnd, buf, MAX_LENGTH)
        app_text = buf.Substring(0, length)

        length = GetClassName(app_hwnd, buf, MAX_LENGTH)
        app_class = buf.Substring(0, length)
    End Sub





















    Private Function getTime() As Integer
        Dim totalTime As Integer = 0
        Dim timeString As String = txtTime.Text
        Dim str As String
        Dim strArray As String() = timeString.Split(":"c)

        'full hour:min:sec
        If (strArray.Length = 3) Then
            totalTime = CInt(strArray(0)) * 3600 + CInt(strArray(1)) * 60 + CInt(strArray(2))
        End If
        'min:sec
        If (strArray.Length = 2) Then
            totalTime = CInt(strArray(0)) * 60 + CInt(strArray(1))
        End If
        'min:sec
        If (strArray.Length = 1) Then
            totalTime = CInt(strArray(0))
        End If

        Return totalTime
    End Function

    Private Sub setTime(ByVal totalTime As Integer)
        Dim hour As Integer
        Dim min As Integer
        Dim sec As Integer

        hour = CInt(Math.Floor(totalTime / 3600))
        totalTime = totalTime - (hour * 3600)
        min = CInt(Math.Floor(totalTime / 60))
        sec = totalTime Mod 60

        Dim strhour As String
        Dim strmin As String
        Dim strsec As String

        If (hour < 10) Then strhour = "0"
        If (min < 10) Then strmin = "0"
        If (sec < 10) Then strsec = "0"
        strhour = strhour + CStr(hour).Trim()
        strmin = strmin + CStr(min).Trim()
        strsec = strsec + CStr(sec).Trim()
        Me.txtTime.Text = strhour + ":" + strmin + ":" + strsec
    End Sub

    Private Function timeValid(ByVal txt As String) As Boolean
        Dim max5 As String = "(([0-9])|([0-9][0-9])|([0-9][0-9][0-9])|([0-9][0-9][0-9][0-9])|([0-9][0-9][0-9][0-9][0-9]))"
        Dim regex As System.Text.RegularExpressions.Regex = New System.Text.RegularExpressions.Regex("^(((" + max5 + ":([0-5][0-9]):([0-5][0-9])))|(((([0-5][0-9])|([0-9])):([0-5][0-9])))|((([0-5][0-9])|([0-9]))))$")

        If Not (regex.IsMatch(txt)) Then
            Return False
        End If
        Return True
    End Function

    Private Sub TextBox1_Validating(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtTime.Validating
        If Not timeValid(txtTime.Text) Then
            MessageBox.Show("Cannot parse time, valid formats are h*:mm:ss, m*:ss and s*", "Parse Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            setTime(getTime())
        End If

    End Sub



    Private Sub scrollHour_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles scrollHour.Scroll
        Dim totalTime As Integer = getTime()

        If e.Type = ScrollEventType.SmallIncrement Then
            totalTime = totalTime - 3600
        End If
        If e.Type = ScrollEventType.SmallDecrement Then
            totalTime = totalTime + 3600
        End If

        If (totalTime < 0) Then totalTime = 0
        setTime(totalTime)
    End Sub

    Private Sub scrollMin_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles scrollMin.Scroll
        Dim totalTime As Integer = getTime()

        If e.Type = ScrollEventType.SmallIncrement Then
            totalTime = totalTime - 60
        End If
        If e.Type = ScrollEventType.SmallDecrement Then
            totalTime = totalTime + 60
        End If

        If (totalTime < 0) Then totalTime = 0
        setTime(totalTime)

    End Sub

    Private Sub scrollSec_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles scrollSec.Scroll
        Dim totalTime As Integer = getTime()

        If e.Type = ScrollEventType.SmallIncrement Then
            totalTime = totalTime - 1
        End If
        If e.Type = ScrollEventType.SmallDecrement Then
            totalTime = totalTime + 1
        End If

        If (totalTime < 0) Then totalTime = 0
        setTime(totalTime)


    End Sub


    Private Function parseLine(ByVal commandline As String) As String()
        Dim arr As ArrayList = New ArrayList()


        Dim i As Integer
        Dim holder As String = ""
        Dim indoublequote As Boolean = False


        For i = 0 To commandline.Length - 1
            If commandline.Substring(i, 1) = """" Then
                If indoublequote = True Then
                    indoublequote = False
                    arr.Add(holder)
                    holder = ""
                Else
                    indoublequote = True
                    If (holder <> "") Then arr.Add(holder)
                    holder = ""
                End If
            Else
                If commandline.Substring(i, 1) = " " And indoublequote = False Then
                    If holder <> "" Then arr.Add(holder)
                    holder = ""
                Else
                    holder = holder + commandline.Substring(i, 1)
                End If
            End If
        Next
        If holder <> "" Then arr.Add(holder)


        Dim strs(arr.Count - 1) As String
        For i = 0 To arr.Count - 1
            strs(i) = DirectCast(arr.Item(i), String)
        Next
        Return strs

    End Function


    Public Sub handleCommandline()
        ' Declare variables.
        Dim commands As String = Microsoft.VisualBasic.Command()
        Dim args() As String = parseLine(commands)


        Dim didError As Boolean = False
        Dim i As Integer

        For i = 0 To args.Length - 1
            Dim arg As String = args(i)

            If Microsoft.VisualBasic.Left(arg, 1) = "-" Or Microsoft.VisualBasic.Left(arg, 1) = "/" Then

                Dim mainarg As String = arg.Substring(1)
                If mainarg = "time" Then
                    If i = args.Length - 1 Then
                        'Console.WriteLine("ERROR: Cannot parse time, valid formats are h*:mm:ss, m*:ss and s*")
                        didError = True

                    Else
                        Dim timearg As String = args(i + 1)
                        i = i + 1
                        If Not timeValid(timearg) Then
                            'Console.WriteLine("ERROR: Cannot parse time, valid formats are h*:mm:ss, m*:ss and s*")
                            didError = True
                        Else
                            Me.txtTime.Text = timearg
                            setTime(getTime())
                        End If
                    End If
                End If

                If mainarg = "start" Then
                    handleToggle()
                End If
                If mainarg = "screensaveron" Then
                    Me.chkActivateScreenSaver.Checked = True
                End If
                If mainarg = "screensaveroff" Then
                    Me.chkActivateScreenSaver.Checked = False
                End If
                If mainarg = "closeselfon" Then
                    Me.chkCloseOnTimeout.Checked = True
                End If
                If mainarg = "closeselfoff" Then
                    Me.chkCloseOnTimeout.Checked = False
                End If
                If mainarg = "killon" Then
                    Me.chkKillProcess.Checked = True
                End If
                If mainarg = "killoff" Then
                    Me.chkKillProcess.Checked = False
                End If

                If mainarg = "app" Then
                    If i = args.Length - 1 Then
                        'Console.WriteLine("ERROR: Parameter missing")
                        didError = True
                    Else
                        Dim appsearch As String = args(i + 1)
                        i = i + 1
                        Dim j As Integer
                        Dim found As Boolean = False
                        For j = 0 To Me.lvWindow.Items.Count - 1
                            Dim name As String = ""
                            Dim countCol As Integer = 0
                            For countCol = 0 To Me.lvWindow.Items(j).SubItems.Count - 1
                                name = name + " " + Me.lvWindow.Items(j).SubItems.Item(countCol).text
                            Next


                            If name.ToUpper.IndexOf(appsearch.ToUpper) <> -1 Then
                                Me.lvWindow.Items(j).Checked = True
                                found = True
                            End If
                        Next
                        If Not found Then
                            'Console.WriteLine("WARN: Found no application with search string '" + appsearch + "'")
                        End If
                    End If
                End If


                If mainarg = "proc" Then
                    If i = args.Length - 1 Then
                        'Console.WriteLine("ERROR: Parameter missing")
                        didError = True
                    Else
                        Dim appsearch As String = args(i + 1)
                        i = i + 1
                        Dim j As Integer
                        Dim found As Boolean = False


                        For j = 0 To Me.lvProcess.Items.Count - 1
                            Dim name As String = ""
                            Dim countCol As Integer = 0
                            For countCol = 0 To Me.lvProcess.Items(j).SubItems.Count - 1
                                name = name + " " + Me.lvProcess.Items(j).SubItems.Item(countCol).text
                            Next

                            If name.ToUpper.IndexOf(appsearch.ToUpper) <> -1 Then
                                Me.lvProcess.Items(j).Checked = True
                                found = True
                            End If
                            ' MsgBox(name)
                        Next


                        If Not found Then
                            'Debug.WriteLine("WARN: Found no process with search string '" + appsearch + "'")
                            'MsgBox("WARN: Found no process with search string '" + appsearch + "'")
                        End If
                    End If
                End If

            End If
        Next
        If didError = True Then
            'MsgBox("Errors, bailing out")
            'Me.Close()
        End If
    End Sub



    Public Sub MonitorOn()

        SendMessage(Me.Handle.ToInt32, WM_SYSCOMMAND, SC_MONITORPOWER, MONITOR_ON)
    End Sub

    Public Sub MonitorOff()
        SendMessage(Me.HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, MONITOR_OFF)
    End Sub





    Private Sub MenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem1.Click
        Dim about As frmAbout = New frmAbout()
        about.ShowDialog(Me)
    End Sub

    Private Sub MenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem2.Click
        Dim commandline As frmCommandLine = New frmCommandLine()
        commandline.ShowDialog(Me)
    End Sub


    Friend WithEvents TabPage1 As System.Windows.Forms.TabPage

    Private Sub TabPage1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TabPage1.Click

    End Sub


    Private Sub txtConfirm_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtConfirm.TextChanged
        If Me.txtConfirm.Text.ToUpper = "CONFIRM" Then
            Me.radLogoff.Enabled = True
            Me.radRestart.Enabled = True
            Me.radShutdown.Enabled = True
            Me.chkForce.Enabled = True
        Else
            Me.radLogoff.Enabled = False
            Me.radRestart.Enabled = False
            Me.radShutdown.Enabled = False
            Me.radNone.Checked = True
            Me.chkForce.Enabled = False
        End If

    End Sub
    Friend WithEvents NotifyIcon1 As System.Windows.Forms.NotifyIcon

    Private Sub NotifyIcon1_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles NotifyIcon1.DoubleClick

        If (Me.WindowState = FormWindowState.Minimized) Then
            Me.Show()
            Me.WindowState = FormWindowState.Normal
            Me.Activate()
            Me.NotifyIcon1.Visible = False

        End If

        ' Activate the form.

    End Sub


    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        If (Me.menuMinimizeTray.Checked = True) Then
            If Me.WindowState = FormWindowState.Minimized Then Me.Hide()
            Me.NotifyIcon1.Visible = True
        End If
    End Sub


    Private Sub menuMinimizeTray_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuMinimizeTray.Click
        If menuMinimizeTray.Checked = True Then
            menuMinimizeTray.Checked = False
        Else
            menuMinimizeTray.Checked = True
        End If
    End Sub



    Private Sub AdjustToken()
        Const TOKEN_ADJUST_PRIVILEGES As Short = &H20S
        Const TOKEN_QUERY As Short = &H8S
        Const SE_PRIVILEGE_ENABLED As Short = &H2S
        Dim hdlProcessHandle As Integer
        Dim hdlTokenHandle As Integer
        Dim tmpLuid As LUID
        Dim tkp As TOKEN_PRIVILEGES
        Dim tkpNewButIgnored As TOKEN_PRIVILEGES
        Dim lBufferNeeded As Integer
        hdlProcessHandle = GetCurrentProcess()
        OpenProcessToken(hdlProcessHandle, TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, hdlTokenHandle)
        LookupPrivilegeValue("", "SeShutdownPrivilege", tmpLuid)
        tkp.PrivilegeCount = 1 ' One privilege to set
        tkp.TheLuid = tmpLuid
        tkp.Attributes = SE_PRIVILEGE_ENABLED
        AdjustTokenPrivileges(hdlTokenHandle, CInt(False), tkp, Len(tkpNewButIgnored), tkpNewButIgnored, lBufferNeeded)

    End Sub







    Private Sub muStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles muStartStop.Click
        handleToggle()
    End Sub



    Private Sub miQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles miQuit.Click
        Me.Close()
    End Sub

    Private Sub Processes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Processes.Click

    End Sub
    Friend WithEvents chkShowAllUser As System.Windows.Forms.CheckBox

    Private Sub chkShowAllUser_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkShowAllUser.CheckedChanged
        refreshApp()
    End Sub

    Private Sub lvProcess_ItemCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckEventArgs) Handles lvProcess.ItemCheck
        'this is a cheese to handle what used to be readonly properties of a kind present in checked list boxes
        If Timer1.Enabled Then
            e.NewValue = e.CurrentValue
        Else
            Dim num As Integer
            num = DirectCast(sender, ListView).CheckedItems.Count
            If (e.NewValue = CheckState.Checked) Then num = num + 1
            If (e.NewValue = CheckState.Unchecked) Then num = num - 1
            Me.Label1.Text = CStr(num) + " Process(es) and " + CStr(Me.lvWindow.CheckedItems.Count) + " Window(s) Selected"
            If Me.radLogoff.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Log Off"
            If Me.radRestart.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Restart"
            If Me.radShutdown.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Shut Down"

        End If
    End Sub

    Private Sub lvWindow_ItemCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckEventArgs) Handles lvWindow.ItemCheck
        'this is a cheese to handle what used to be readonly properties of a kind present in checked list boxes

        If Timer1.Enabled Then
            e.NewValue = e.CurrentValue
        Else
            Dim num As Integer = 0
            num = DirectCast(sender, ListView).CheckedItems.Count


            If (e.NewValue = CheckState.Checked) Then num = num + 1
            If (e.NewValue = CheckState.Unchecked) Then num = num - 1
            Me.Label1.Text = CStr(Me.lvProcess.CheckedItems.Count) + " Process(es) and " + CStr(num) + " Window(s) Selected"
            If Me.radLogoff.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Log Off"
            If Me.radRestart.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Restart"
            If Me.radShutdown.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Shut Down"

        End If
    End Sub

    Private Sub lvProcess_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvProcess.SelectedIndexChanged
        'more cheese to defeat other problems
        If Timer1.Enabled Then
            CType(sender, ListView).SelectedItems.Clear()
        End If
    End Sub

    Private Sub lvWindow_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvWindow.SelectedIndexChanged
        'more cheese to defeat other problems
        If Timer1.Enabled Then
            CType(sender, ListView).SelectedItems.Clear()
        End If
    End Sub

    Private Sub lvProcess_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles lvProcess.ColumnClick
        ' Get the new sorting column.
        Dim new_sorting_column As ColumnHeader = lvProcess.Columns(e.Column)

        ' Figure out the new sorting order.
        Dim sort_order As System.Windows.Forms.SortOrder

        If m_ProcessSortingColumn.m_SortingColumn Is Nothing Then
            ' New column. Sort ascending.
            sort_order = SortOrder.Ascending
            'lvProcess.Sorting = SortOrder.Ascending
        Else
            ' See if this is the same column.
            If new_sorting_column.Equals(m_ProcessSortingColumn.m_SortingColumn) Then
                ' Same column. Switch the sort order.

                'If m_ProcessSortingColumn.Text.StartsWith("> ") Then
                If m_ProcessSortingColumn.m_SortingStyle = SortOrder.Ascending Then
                    sort_order = SortOrder.Descending
                Else
                    sort_order = SortOrder.Ascending
                End If
                'If lvProcess.Sorting = SortOrder.Ascending Then
                '    lvProcess.Sorting = SortOrder.Descending
                'Else
                'lvProcess.Sorting = SortOrder.Ascending
                'End If
            Else
                ' New column. Sort ascending.
                sort_order = SortOrder.Ascending
                'lvProcess.Sorting = SortOrder.Ascending
            End If

            ' Remove the old sort indicator.
            'm_ProcessSortingColumn.Text = m_ProcessSortingColumn.Text.Substring(2)
        End If

        ' Display the new sort order.
        m_ProcessSortingColumn.m_SortingColumn = new_sorting_column

        'If sort_order = SortOrder.Ascending Then
        'm_ProcessSortingColumn.Text = "> " & m_ProcessSortingColumn.Text
        'Else
        '    m_ProcessSortingColumn.Text = "< " & m_ProcessSortingColumn.Text
        'End If
        m_ProcessSortingColumn.m_SortingStyle = sort_order

        ' Create a comparer.
        If Me.ProcessCheck.Index = e.Column Then
            lvProcess.ListViewItemSorter = New ListViewBooleanComparer(e.Column, sort_order)
        ElseIf Me.PID.Index = e.Column Then
            lvProcess.ListViewItemSorter = New ListViewIntegerComparer(e.Column, sort_order)
        Else
            lvProcess.ListViewItemSorter = New ListViewStringComparer(e.Column, sort_order)
        End If


        ' Sort.
        lvProcess.Sort()
    End Sub


    Private Sub lvWindow_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles lvWindow.ColumnClick
        ' Get the new sorting column.

        Dim new_sorting_column As ColumnHeader = lvWindow.Columns(e.Column)

        ' Figure out the new sorting order.
        Dim sort_order As System.Windows.Forms.SortOrder
        If m_WindowSortingColumn.m_SortingColumn Is Nothing Then
            sort_order = SortOrder.Ascending
        Else
            If new_sorting_column.Equals(m_WindowSortingColumn.m_SortingColumn) Then
                ' Same column. Switch the sort order.
                'If m_WindowSortingColumn.m_SortingColumn.Text.StartsWith("> ") Then
                If m_WindowSortingColumn.m_SortingStyle = SortOrder.Ascending Then
                    sort_order = SortOrder.Descending
                Else
                    sort_order = SortOrder.Ascending
                End If
            Else
                ' New column. Sort ascending.
                sort_order = SortOrder.Ascending
            End If

            ' Remove the old sort indicator.
            'm_WindowSortingColumn.Text = m_WindowSortingColumn.Text.Substring(2)
        End If

        ' Display the new sort order.
        m_WindowSortingColumn.m_SortingColumn = new_sorting_column
        m_WindowSortingColumn.m_SortingStyle = sort_order
        'If sort_order = SortOrder.Ascending Then
        'm_WindowSortingColumn.Text = "> " & m_WindowSortingColumn.Text
        'Else
        '    m_WindowSortingColumn.Text = "< " & m_WindowSortingColumn.Text
        'End If

        ' Create a comparer.
        If Me.windowCheck.Index = e.Column Then
            lvWindow.ListViewItemSorter = New ListViewBooleanComparer(e.Column, sort_order)
        Else
            lvWindow.ListViewItemSorter = New ListViewStringComparer(e.Column, sort_order)
        End If

        ' Sort.
        lvWindow.Sort()
    End Sub

    Private Sub radio_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radLogoff.CheckedChanged, radRestart.CheckedChanged, radShutdown.CheckedChanged
        Me.Label1.Text = CStr(lvProcess.SelectedItems.Count) + " Process(es) and " + CStr(lvWindow.SelectedItems.Count) + " Window(s) Selected"
        If Me.radLogoff.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Log Off"
        If Me.radRestart.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Restart"
        If Me.radShutdown.Checked = True Then Me.Label1.Text = Me.Label1.Text + "  System: Shut Down"
    End Sub

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        DeregisterShellHookWindow(Me.Handle)
    End Sub
    Friend WithEvents ProcessCheck As System.Windows.Forms.ColumnHeader
    Friend WithEvents windowCheck As System.Windows.Forms.ColumnHeader

    Private Sub butAppSelectNone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butAppSelectNone.Click
        Dim lvItem As ListViewItem
        For Each lvItem In lvWindow.Items
            lvItem.Checked = False
        Next
    End Sub

    Friend WithEvents butProcessSelectNone As System.Windows.Forms.Button
    Friend WithEvents butAppSelectNone As System.Windows.Forms.Button

    Private Sub butProcessSelectNone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butProcessSelectNone.Click
        Dim lvItem As ListViewItem
        For Each lvItem In lvProcess.Items
            lvItem.Checked = False
        Next

    End Sub
    Friend WithEvents chkDynamicUpdateList As System.Windows.Forms.CheckBox


    'THIS WAS FOR MOVING THE FORM AROUND VIA THE FORM ITSELF
    'Private Sub Form1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove
    '    Dim curPoint As System.Drawing.Point = Me.PointToScreen(New System.Drawing.Point(e.X, e.Y))


    '    If e.Button = MouseButtons.Left Then
    '        Me.Location = New System.Drawing.Point(Me.Location.X + (curPoint.X - _lastMouseX), Me.Location.Y + (curPoint.Y - _lastMouseY))
    '    End If
    '    Debug.WriteLine(curPoint.X.ToString + "  " + curPoint.Y.ToString + "  " + "DELTA: " + (curPoint.X - _lastMouseX).ToString + "  " + (curPoint.Y - _lastMouseY).ToString)

    '    _lastMouseX = curPoint.X
    '    _lastMouseY = curPoint.Y
    'End Sub


    'Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
    '    If e.Button = MouseButtons.Left Then
    '        _lastMouseX = e.X
    '        _lastMouseY = e.Y
    '    End If
    'End Sub
End Class
